com.smartgwt.client.types

## Enum ListGridFieldType

- java.lang.Object
- - java.lang.Enum<ListGridFieldType>
  - - com.smartgwt.client.types.ListGridFieldType

- All Implemented Interfaces:
    ValueEnum, java.io.Serializable, java.lang.Comparable<ListGridFieldType>

      public enum ListGridFieldType
      extends java.lang.Enum<ListGridFieldType>
      implements ValueEnum

  ListGrids format data for viewing and editing based on the type attribute of the field. This table describes how the ListGrid deals with the various built-in types.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BINARY` For viewing, the grid renders a 'view' icon (looking glass) followed by a 'download' icon and then the name of the file is displayed in text.
    `BOOLEAN` For viewing and editing a checkbox is shown with a check mark for the `true` value and no check mark for the `false` value.
    `DATE` Field value should be a `Date` instance representing a logical date, with no time of day information.
    `DATETIME` Field value should be a `Date` instance representing a specific date and time value.
    `FLOAT` Same as `text`.
    `ICON` Shows `field.icon` in every cell, and also in the header.
    `IMAGE` Renders a different image in each row based on the value of the field.
    `IMAGEFILE` Same as `binary`
    `INTEGER` Same as `text`.
    `LINK` Renders a clickable html link (using an HTML anchor tag: <A>).
    `SEQUENCE` Same as `text`
    `SUMMARY` Show a calculated summary based on other field values within the current record.
    `TEXT` Simple text rendering for view.
    `TIME` Field value should be a `Date` instance representing a logical time, meaning time value that does not have a specific day and also has no timezone.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getValue()`
    `static ListGridFieldType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static ListGridFieldType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TEXT

          public static final ListGridFieldType TEXT

      Simple text rendering for view. For editing a text entry field is shown. If the length of the field (as specified by the `length` attribute) is larger than the value specified by `longTextEditorThreshold`, a text input icon is shown that, when clicked on (or field is focused in) opens a larger editor that expands outside the boundaries of the cell (textarea by default, but overrideable via `longTextEditorType`).

    - #### BOOLEAN

          public static final ListGridFieldType BOOLEAN

      For viewing and editing a checkbox is shown with a check mark for the `true` value and no check mark for the `false` value. This behavior may be suppressed by setting link{listGridField.suppressValueIcon} for the field. See `booleanTrueImage` for customization.

    - #### INTEGER

          public static final ListGridFieldType INTEGER

      Same as `text`. Consider setting `editorType` to use a `SpinnerItem`.

    - #### FLOAT

          public static final ListGridFieldType FLOAT

      Same as `text`. Consider setting `editorType` to use a `SpinnerItem`.

    - #### DATE

          public static final ListGridFieldType DATE

      Field value should be a `Date` instance representing a logical date, with no time of day information. See `DateFormatAndStorage` for details of the logical date type and how it is represented and manipulated.

      Dates will be formatted using `ListGridField.dateFormatter` if specified, otherwise `ListGrid.dateFormatter`. If both these attributes are unset, dates are formatted using the standard `short display format` for dates.

      For editing, by default a `DateItem` is used with `useTextField` set to true, providing textual date entry plus a pop-up date picker. The `dateFormatter` and `inputFormat` for the editor will be picked up from the ListGridField, if specified.

    - #### TIME

          public static final ListGridFieldType TIME

      Field value should be a `Date` instance representing a logical time, meaning time value that does not have a specific day and also has no timezone. See `DateFormatAndStorage` for details of the logical time type and how it is represented and manipulated.

      Times will be formatted using `ListGridField.timeFormatter` if specified, otherwise `ListGrid.timeFormatter`.

      If both these attributes are unset, times are formatted using the standard String for times.

      For editing, by default a `TimeItem` is used. The `timeFormatter` for the editor will be picked up from the ListGridField, if specified.

    - #### DATETIME

          public static final ListGridFieldType DATETIME

      Field value should be a `Date` instance representing a specific date and time value. See `DateFormatAndStorage` for details of the datetime type and how it is represented and manipulated.

      Dates will be formatted using `ListGridField.dateFormatter` if specified, otherwise `ListGrid.datetimeFormatter`. If both these attributes are unset, dates are formatted using the standard `short display format` for datetime values.

      For editing, by default a `DateTimeItem` is used, providing textual date entry plus a pop-up date picker. The `dateFormatter` and `inputFormat` for the editor will be picked up from the ListGridField, if specified.

    - #### SEQUENCE

          public static final ListGridFieldType SEQUENCE

      Same as `text`

    - #### LINK

          public static final ListGridFieldType LINK

      Renders a clickable html link (using an HTML anchor tag: <A>). The target URL is the value of the field, which is also the default display value. You can override the display value by setting `linkText` or `linkText`.

      Clicking the link opens the URL in a new window by default. To change this behavior, you can set `field.target`, which works identically to the "target" attribute on an HTML anchor (<A>) tag. See `target` for more information.

      In inline edit mode, this type works like a text field.

      To create a link not covered by this feature, consider using `ListGridField.formatCellValue` along with `Canvas.linkHTML`, or simply `styling the field` to look like a link, and providing interactivity via `field.recordClick()`.

    - #### IMAGE

          public static final ListGridFieldType IMAGE

      Renders a different image in each row based on the value of the field. If this URL is not absolute, it is assumed to be relative to `imageURLPrefix` if specified. The size of the image is controlled by `imageSize`, `imageWidth`, `imageHeight` (and by the similarly-named global default attributes on the ListGrid itself).

      You can also specify the following attributes on the field: `activeAreaHTML`, and `extraStuff` - these are passed to `Canvas.imgHTML` to generate the final URL.

      Note if you want to display icons in addition to the normal cell value, you can use `valueIcons` instead.

    - #### ICON

          public static final ListGridFieldType ICON

      Shows `field.icon` in every cell, and also in the header. Useful for a field that is used as a button, for example, launches a detail window or removes a row. Implement a `field.recordClick` to define a behavior for the button.

      NOTE: for a field that shows different icons depending on the field value, see `valueIcons`.

      `type:"icon"` also defaults to a small field width, accommodating just the icon with padding, and to a blank header title, so that the header shows the icon only.

      `field.iconWidth` and related properties configure the size of the icon both in the header and in body cells.

      If you want the icon to appear only in body cells and not in the header, set `field.cellIcon` instead, leaving field.icon null.

    - #### BINARY

          public static final ListGridFieldType BINARY

      For viewing, the grid renders a 'view' icon (looking glass) followed by a 'download' icon and then the name of the file is displayed in text. If the user clicks the 'view' icon, a new browser window is opened and the file is streamed to that browser instance, using `DataSource.viewFile`. For images and other file types with known handlers, the content is typically displayed inline - otherwise the browser will ask the user how to handle the content. If the download icon is clicked, `DataSource.downloadFile` is used to cause the browser to show a "save" dialog. There is no inline editing mode for this field type.

    - #### IMAGEFILE

          public static final ListGridFieldType IMAGEFILE

      Same as `binary`

    - #### SUMMARY

          public static final ListGridFieldType SUMMARY

      Show a calculated summary based on other field values within the current record. See `recordSummaryFunction` for more information

  - ### Method Detail

    - #### values

          public static ListGridFieldType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ListGridFieldType c : ListGridFieldType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ListGridFieldType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getValue

          public java.lang.String getValue()

      Specified by:
        `getValue` in interface `ValueEnum`